(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

let bool_of_opt = function
  | None -> false
  | _ -> true;;

let value = function
  | Some x -> x
  | None -> raise (Invalid_argument "value");;

module OrdStr = struct
  type t = string;;
  let compare = Pervasives.compare;;
end;;

module StrMap = Map.Make (OrdStr);;
module StrSet = Set.Make (OrdStr);;

module OrdInt = struct
  type t = int;;
  let compare = Pervasives.compare;;
end;;

module IntMap = Map.Make (OrdInt);;
module IntSet = Set.Make (OrdInt);;

type 'a bprint = Buffer.t -> 'a -> unit;;

module type ORD_PRT = sig
  type t;;
  val compare : t -> t -> int;;
  val bprint : t bprint;;
end;;

let new_line p b x = Printf.bprintf b "%a\n" p x;;

let bprint_pair sep func b (x,y) = Printf.bprintf b "%a%s%a" func x sep func y;;

type 'a fprint = out_channel -> 'a -> unit;;

let b = Buffer.create 1024;;

let to_channel func c arg =
  Printf.bprintf b "%a" func arg;
  Buffer.output_buffer c b;
  Buffer.clear b;;
