(* $Id: funutils.ml,v 1.1 2007/11/22 17:16:47 lowenthl Exp $ *)

(** {Miscelaneous function functions} *)

(** Identity function *)
let id x = x
;;

(** Function composition *)
let comp f g = fun x -> f (g x)
let (<.>) = comp
;;

(** Operator for function application. f $ g y = f (g y), avoiding *)
 (** parentheses. Right associative. *)
let apply f x = f x
let (^$) = apply
;;

(** Flips the arguments of a function. *)
let flip f x y = f y x
;;
