(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Laura Lowenthal, projet Protheo, INRIA Lorraine           *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: genr_testing.mli,v 1.4 2008/01/10 18:06:58 lowenthl Exp $ *)

(** {Generation of testing expressions for a moca type declaration.} *)

val genr_and_print_test :
  Buffer.t -> string -> bool -> int -> int -> (string * Parsetree.type_declaration) list -> unit
;;
(** The global test generation procedure: it generates and prints the whole set of value definitions and test expressions from a given module name and type definition. The boolean argument indicate if values should be generated randomly. The integer arguments indicate the number of tests to generate per equation, and the maximal constructor depth of the generated values, respectively. *)
