(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Laura Lowenthal, projet Protheo, INRIA Lorraine           *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: randomutils.ml,v 1.1 2008/01/10 18:06:58 lowenthl Exp $ *)

(** {Functions for dealing with random values} *)

let ints n bound = Listutils.map_from_to (fun _ -> Random.int bound) 1 n succ

let choose_one list = 
  let bound = List.length list in
  List.nth list (Random.int bound)

let choose_many n list = 
  if Listutils.null list
  then []
  else Listutils.map_from_to (fun _ -> choose_one list) 1 n succ
